"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SolanaChain = void 0;
const connect_sdk_1 = require("@wormhole-foundation/connect-sdk");
const spl_token_1 = require("@solana/spl-token");
const platform_1 = require("./platform");
const address_1 = require("./address");
class SolanaChain extends connect_sdk_1.ChainContext {
    // @ts-ignore
    platform = platform_1.SolanaPlatform;
    async getTokenAccount(token, address) {
        const tb = await this.getTokenBridge();
        const mintAddress = token === 'native'
            ? await tb.getWrappedNative()
            : token.toUniversalAddress();
        const mint = new address_1.SolanaAddress(mintAddress.toUint8Array()).unwrap();
        const owner = new address_1.SolanaAddress(address).unwrap();
        const ata = await (0, spl_token_1.getAssociatedTokenAddress)(mint, owner);
        return (0, connect_sdk_1.toNative)('Solana', ata.toString());
    }
}
exports.SolanaChain = SolanaChain;
//# sourceMappingURL=chain.js.map