import { ChainContext, toNative, } from '@wormhole-foundation/connect-sdk';
import { getAssociatedTokenAddress } from '@solana/spl-token';
import { SolanaPlatform } from './platform';
import { SolanaAddress } from './address';
export class SolanaChain extends ChainContext {
    // @ts-ignore
    platform = SolanaPlatform;
    async getTokenAccount(token, address) {
        const tb = await this.getTokenBridge();
        const mintAddress = token === 'native'
            ? await tb.getWrappedNative()
            : token.toUniversalAddress();
        const mint = new SolanaAddress(mintAddress.toUint8Array()).unwrap();
        const owner = new SolanaAddress(address).unwrap();
        const ata = await getAssociatedTokenAddress(mint, owner);
        return toNative('Solana', ata.toString());
    }
}
//# sourceMappingURL=chain.js.map